#!/usr/bin/python
# -*- coding: utf-8 -*-

import string
import os
import gtk
import re

default_dictdir = "/usr/share/pydict"
prop = [" "," "," ","<<形容詞>>","<<副詞>>","art. ","<<連接詞>>","int.  ","<<名>詞>>"," "," ","num. ",  "prep. "," ","pron.  ","<<動詞>>","<<助動詞>>","<<非及物動詞>>","<<及物動詞>>","vbl. "," ","st. ", "pr. ","<<過去分詞>>","<<複數>>","ing. "," ","<<形容詞>>","<<副詞>>","pla. ","pn. "," "]

class dictBackend:
    def __init__(self):
        self.entries = []
        self.smartsearch = 0
	self.english = 0

    # change proposition
    def change_prop(self, str):
	start=0
	end=0
	mean_list = []
	tmp = str
	for x in range(len(prop)):
		tmp = string.replace(tmp,chr(x),'@@'+prop[x])
	return tmp

    # display soundmarks
    def change_pron(self, str):
	tmp = ''
	for x in range(len(str)):
	    if str[x] == chr(0x01):
		    tmp = tmp + 'I'
	    elif str[x] == chr(0x02):
		    tmp = tmp + 'E'
	    elif str[x] == chr(0x03):
		    tmp = tmp + 'ae'
	    elif str[x] == chr(0x04):
		    tmp = tmp + 'a'
	    elif str[x] == chr(0x06):
		    tmp = tmp + 'c'
	    elif str[x] == chr(0x0b):
		    tmp = tmp + '8'
	    elif str[x] == chr(0x0e):
		    tmp = tmp + 'U'
	    elif str[x] == chr(0x0f):
		    tmp = tmp + '^'
	    elif str[x] == chr(0x10):
		    tmp = tmp + '2'
	    elif str[x] == chr(0x11):
		    tmp = tmp + '2*'
	    elif str[x] == chr(0x13):
		    tmp = tmp + '2~'
	    elif str[x] == chr(0x17):
		    tmp = tmp + 'l.'
	    elif str[x] == chr(0x19):
		    tmp = tmp + 'n_'
	    elif str[x] == chr(0x1c):
		    tmp = tmp + '&'
	    elif str[x] == chr(0x1d):
		    tmp = tmp + 'S'
	    elif str[x] == chr(0x1e):
		    tmp = tmp + '3'
	    elif str[x] == chr(0x65) and x == 0:
		    pass
	    else:
		    tmp = tmp + str[x]
	return tmp

    # transform line to word, meanning_list, mark	
    def process_line(self, str):
	temp = {}
	split_word = string.split(str,'=')
	temp['word'] = split_word[0]
	lines = string.split(self.change_prop(split_word[1]),'@@')
	temp['mean'] = lines
	if len(split_word) == 3 and split_word[2] != '\n':
	    temp['mark'] = self.change_pron(split_word[2][:-1])
	return temp

    def search_word(self, str, update_list, search_all):
        text = gtk.TextBuffer(None)
        
        # filter some characters to use with command
        p = re.compile('[1-9\|\"\']+')
	pstr = p.sub('', str)
	filename = string.lower(pstr[0]) + '.lib'

	if self.smartsearch or search_all:
	    filename = '*'
	    word = '"' + pstr + '" '
	    option = '--no-filename '
	else:
	    word = '"^' + pstr + '=" '
	    option = '--after-context=20 --no-filename '

        if not update_list:
            filename = string.lower(pstr[0]) + '.lib'

        command = 'grep -ir '+ option + word + default_dictdir + '/' + filename

	# open, readline the stream and close it
        fd = os.popen(command,'r')
        self.entries = fd.readlines()
        fd.close()

	# proccess if there are any results
        if self.entries: 
	    meaning = self.process_line(self.entries[0])
	    all = meaning['word'] + '\n\n'

            #if have voicemark, display it
	    if meaning.has_key('mark'):
     	        all = all + '[' + meaning['mark'] + ']\n'
		
	    for i in range(len(meaning['mean'])):
		all = all + '\n' + meaning['mean'][i]
            text.set_text(all, -1)

        else:
            text.set_text(str + ' not found.', -1)

        return text
